/* FaceTrackerV2
   By: Francisco Dias - XicoMBD
   27 October 2010
*/

import processing.serial.*;
import pFaceDetect.*;
import JMyron.*;
import controlP5.*;

ControlP5 controlP5;
Serial TheBox;
PFaceDetect face;
JMyron m;
Textfield myTextfield;


PImage img;

int xmin = 130;
int xmax = 190;

int cx=160; //Bounding box x center
int xd=0; 


String COMPort = "";

int stage = 0;


void setup() {
  size(320,350);
  m = new JMyron();
  m.start(320,240);
  m.findGlobs(0);
  face = new PFaceDetect(this,320,240,
  "haarcascade_frontalface_default.xml");
  frameRate(15);
  img = createImage(320,240,ARGB);
  rectMode(CORNER);
  noFill();
  stroke(255,0,0);
  smooth();
  
 controlP5 = new ControlP5(this);
  controlP5.addSlider("xmin",0,320,xmin,0,240,320,5);
  controlP5.addSlider("xmax",0,320,xmax,0,245,320,5);

  controlP5.addTextfield("COMPort",100,300,100,20);

}

void draw() {
  background(0);

// Defines the COM port
  if (stage==0){
  String[] m1 = match(COMPort, "COM");
    if (m1 != null) {
      // This will print to the console.
      stage=2;
     TheBox = new Serial(this,COMPort,4800);
     println(COMPort);
     size(320,300);
    }  
   } 

  m.update();
  arraycopy(m.cameraImage(),img.pixels);
  img.updatePixels();
  face.findFaces(img);
  image(img,0,0);
  drawFace();
  stroke(255,0,0);
    line(xmin,0,xmin,240); 
    line(xmax,0,xmax,240); 


if (stage==2){
 fill(255);
 text("Commands being sent:",90,270);
  if (xd == 0){
  TheBox.write('g'); 
  println("g - Stop");
  text("g - Stop",120,290);
}
delay(100);
  xd=0; 
}
}

void drawFace() {
   stroke(255,150,0);
  int [][] res = face.getFaces();
  if (res.length>0) {
    for (int i=0;i<res.length;i++) {
      int x = res[i][0];
      int y = res[i][1];
      int w = res[i][2];
      int h = res[i][3];
 noFill();
    rect(x,y,w,h);
    stroke(255,255,0);
    int cx = x+(w/2);
    line(cx,0,cx,240); 
    xd=1;

if (stage==2){
  fill(255);
  text("Commands being sent:",90,270);
  
  if(cx>xmin && cx<xmax){
   TheBox.write('w');
   println("w - Go Foward");
   text("w - Go Foward",120,290);
  }
 if(cx>xmax){
   TheBox.write('w');
   TheBox.write('a');
   println("a - Turn Right");
   text("a - Turn Right",120,290);
  }
 if(cx<xmin){
   TheBox.write('w');
   TheBox.write('d');
   println("d - Turn Left");
   text("d - Turn Left",120,290);
 }

    }
  }
 }


}


public void stop(){
  m.stop();
  super.stop();
}

